//---------------------------------------------------------------------------

#include <vcl.h>
#include <Sockets.hpp>
#include <ScktComp.hpp>
#pragma hdrstop
#include "TcpScannerUnit.h"
#include "connect_thread.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TConnectThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TConnectThread::TConnectThread(AnsiString asAddress,
	AnsiString asPort, int timeout, bool CreateSuspended)
	: TThread(CreateSuspended)
{
    FreeOnTerminate = true;
	scanAddress = asAddress;
	scanPort = asPort;
	conntimeout = timeout;
}

int nonblock_connect(SOCKET sockfd, const struct sockaddr *saptr, int salen, int usec)
{
    int n, error;
    int len;
    fd_set rset, wset;
    struct timeval tval;
	int noblocking = 1;

	ioctlsocket(sockfd, FIONBIO, (unsigned long FAR*)&noblocking);

    error = 0;
    if ((n = connect(sockfd, saptr, salen)) < 0){}
	if (errno == WSAEINPROGRESS)
		return -1;

    if (n == 0)
        goto done;               /* connect completed immediately */

    FD_ZERO(&rset);
    FD_SET(sockfd, &rset);
    wset = rset;
	tval.tv_sec = 0;
	tval.tv_usec = usec;

    if ( (n = select((int)sockfd + 1, &rset, &wset, NULL,usec ? &tval : NULL)) == 0)
    {
        closesocket(sockfd);          /* timeout */
        errno =WSAETIMEDOUT;
        return (-1);
    }

    if (FD_ISSET(sockfd, &rset) || FD_ISSET(sockfd, &wset))
    {
        len = sizeof(error);
        if (getsockopt(sockfd, SOL_SOCKET, SO_ERROR,(char*) &error, &len) < 0)
            return (-1);     /* Solaris pending error */
    }
	//else
    //    puts("select error: sockfd not set");

done:

    noblocking=0;
	ioctlsocket(sockfd, FIONBIO, (unsigned long FAR*)&noblocking);

    if (error)
    {
		closesocket(sockfd);
        errno = error;
		return -1;
    }
    return (0);
}

//---------------------------------------------------------------------------
void __fastcall TConnectThread::Execute()
{
/*
	TTcpClient *tcpClient = new TTcpClient(NULL);
	tcpClient->BlockMode = bmBlocking;
	tcpClient->RemoteHost = scanAddress;
	tcpClient->RemotePort = scanPort;
	tcpClient->Connect();
	if(tcpClient->Connected)
	{
		Synchronize(&AddServer);
	}
	tcpClient->Close();
	delete tcpClient;
	tcpClient = NULL;
	Synchronize(&DecThreadsNo);
*/
/*
	TClientSocket *tcpClient = new TClientSocket(NULL);
	tcpClient->Address = scanAddress;
	tcpClient->Port = StrToInt(scanPort);
	tcpClient->ClientType = ctBlocking;
	tcpClient->Open();
	if(tcpClient->Active)
	{
		Synchronize(&AddServer);
	}
	tcpClient->Close();
	delete tcpClient;
	tcpClient = NULL;
	Synchronize(&DecThreadsNo);
*/
	// Create the socket
	SOCKET theSocket = socket(AF_INET,		// Go over TCP/IP
			   SOCK_STREAM,			// stream-oriented socket
			   IPPROTO_TCP);		// Use TCP

	if (theSocket == INVALID_SOCKET) {
		//int nret = WSAGetLastError();
		return;
	}
	// Fill a SOCKADDR_IN struct with address information
	SOCKADDR_IN serverInfo;
	serverInfo.sin_family = AF_INET;
	serverInfo.sin_port  = htons((unsigned short)StrToInt(scanPort));
	serverInfo.sin_addr.s_addr = inet_addr(scanAddress.c_str());
	// Connect to the server
//	int nret = connect(theSocket,
//			   (LPSOCKADDR)&serverInfo,
//			   sizeof(struct sockaddr));
//	if (nret != SOCKET_ERROR) {
//		Synchronize(&AddServer);
//	}
//  closesocket(theSocket);

	if (nonblock_connect(theSocket, (struct sockaddr *)&serverInfo,
		sizeof(struct sockaddr), conntimeout)==0)
	{
		Synchronize(&AddServer);
		closesocket(theSocket);
	}


	Synchronize(&DecThreadsNo);
}
//---------------------------------------------------------------------------

void __fastcall TConnectThread::AddServer()
{
	TListItem *item = frmTcpScanner->lvFound->Items->Add();
	item->Caption = scanAddress;
}

void __fastcall TConnectThread::DecThreadsNo()
{
	frmTcpScanner->iActiveThreads--;
	frmTcpScanner->StatusBar1->Panels->Items[1]->Text = "Threads: " + IntToStr(frmTcpScanner->iActiveThreads);
}
